Subject: Re: Problem with mini-PCI-E slot on P2020RDB

From: Felix Radensky <[email-masked]>
Date: Wed, 16 Dec 2009 14:00:04 +0200

Mahajan Vivek-B08308 wrote:
>> From: Felix Radensky [mailto:[email-masked]] 
>> Sent: Wednesday, December 16, 2009 2:56 PM
>> To: Mahajan Vivek-B08308
>> Cc: [email-masked]; Aggrwal Poonam-B10812; Kumar Gala
>> Subject: Re: Problem with mini-PCI-E slot on P2020RDB
>>
>> Hi,
>>     
>>> Looks like INTA is not being routed to IRQ0 properly for this PCIe 
>>> ctlr. Try changing the interrupt-map prop for the ctlr at 
>>>       
>> 0xffe0a000 
>>     
>>> to the following, temporarily:-
>>>
>>> interrupt-map = <
>>> /* IDSEL 0x0 */
>>> 0000 0x0 0x0 0x1 &mpic 0x1 0x1
>>> 0000 0x0 0x0 0x2 &mpic 0x2 0x1
>>> 0000 0x0 0x0 0x3 &mpic 0x3 0x1
>>> 0000 0x0 0x0 0x4 &mpic 0x0 0x1
>>>   
>>>       
>> Thanks for your help. With this change "nobody cared" message 
>> disappears, but interrupts are not coming at all.
>>
>> Is it a SoC problem or a board problem ?
>>     
>
> As per the p2020rm, PCIe legacy INTA is shared with IRQ0 for 
> this ctlr, which is the exactly the case with other SoC's 
> p2020ds, mpc8536ds, mpc8572ds. To me it seems like a board 
> issue and it needs to be followed up.
>
> I plugged in ralink rt2860 pcie wirless card in the mini-pcie 
> slot of p2020rdb, which ran fine becaused it used MSI by default.
> How hard is it to enable MSI in the atheros wireless driver.
>
>   

I've enabled MSI in ath9k driver, by simply adding pci_enable_msi() and
pci_disable_msi() at relevant places. The MSI interrupt is allocated.

irq: irq 0 on host /soc@ffe00000/msi@41600 mapped to virtual irq 18
phy0: Atheros AR9280 MAC/BB Rev:2 AR5133 RF Rev:d0: mem=0xf2160000, irq=18

cat /proc/interrupts
           CPU0
 18:          0   FSL-MSI   Edge      ath9k

lspci -v shows that MSI was enabled on device

But I don't get any interrupts. I've posted a question to ath9k list, 
maybe folks there
will have some ideas.

Thanks.

Felix.